import { DeclareConstructor } from "dojo/_base/declare";
import _WidgetBase = require("./_WidgetBase");

interface _Contained {
    /**
     * Returns the previous child of the parent or null if this is the
     * first child of the parent.
     */
    getPreviousSibling<T extends _WidgetBase>(): T;

    /**
     * Returns the next child of the parent or null if this is the last
     * child of the parent.
     */
    getNextSibling<T extends _WidgetBase>(): T;

    /**
     * Returns the index of this widget within its container parent.
     * It returns -1 if the parent does not exist or if the parent is
     * not a dijit/_Container.
     */
    getIndexInParent(): number;
}

declare module "dojo/_base/kernel" {
    interface Dijit {
        _Contained: _ContainedConstructor;
    }
}

type _ContainedConstructor = DeclareConstructor<_Contained>;
declare const _Contained: _ContainedConstructor;
export = _Contained;
